<?php

add_action('admin_menu', 'dfsp_add_settings_menu');
function dfsp_add_settings_menu() {
    add_options_page(__('Free Stock Photos Settings', 'dfsp'), __('Free Stock Photos', 'dfsp'), 'manage_options', 'dfsp_settings', 'dfsp_settings_page');
    add_action('admin_init', 'dfsp_options');
}


function dfsp_options(){
    register_setting('dfsp_options', 'dfsp_options', 'dfsp_options_validate');
    add_settings_section('dfsp_options_section', '', '', 'dfsp_settings');
    // add_settings_field('language-id', __('Language', 'dfsp'), 'dfsp_render_language', 'dfsp_settings', 'dfsp_options_section');
    // add_settings_field('safesearch-id', 'SafeSearch', 'dfsp_render_safesearch', 'dfsp_settings', 'dfsp_options_section');
    add_settings_field('attribution-id', __('Attribution', 'dfsp'), 'dfsp_render_attribution', 'dfsp_settings', 'dfsp_options_section');
    add_settings_field('button-id', __('Button', 'dfsp'), 'dfsp_render_button', 'dfsp_settings', 'dfsp_options_section');
}


function dfsp_render_language(){
    global $dfsp_gallery_languages;
    $options = get_option('dfsp_options');
    $set_lang = substr(get_locale(), 0, 2);
    if (!$options['language']) $options['language'] = $dfsp_gallery_languages[$set_lang]?$set_lang:'en';
    echo '<select name="dfsp_options[language]">';
    foreach ($dfsp_gallery_languages as $k => $v) { echo '<option value="'.$k.'"'.($options['language']==$k?' selected="selected"':'').'>'.$v.'</option>'; }
    echo '</select>';
}

function dfsp_render_safesearch(){
    $options = get_option('dfsp_options');
    echo '<label><input name="dfsp_options[safesearch]" value="true" type="checkbox"'.($options['safesearch']=='true'?' checked="checked"':'').'> '.__('Exclude inappropriate or explicit images', 'dfsp').'</label>';
}

function dfsp_render_attribution(){
    $options = get_option('dfsp_options');
    echo '<label><input name="dfsp_options[attribution]" value="true" type="checkbox"'.(!$options['attribution'] | $options['attribution']=='true'?' checked="checked"':'').'> '.__('Insert image credits', 'dfsp').'</label>';
}

function dfsp_render_button(){
    $options = get_option('dfsp_options');
    echo '<label><input name="dfsp_options[button]" value="true" type="checkbox"'.(!$options['button'] | $options['button']=='true'?' checked="checked"':'').'> '.__('Show Stock button next to "Add Media"', 'dfsp').'</label>';
}


function dfsp_settings_page() { ?>
    <div class="wrap">
    <h2><?= _e('Free Stock Photos', 'dfsp'); ?></h2>
    <form method="post" action="options.php">
        <?php
            settings_fields('dfsp_options');
            do_settings_sections('dfsp_settings');
            submit_button();
        ?>
    </form>
   <!--  <hr style="margin-bottom:20px">
    <p>
        Official <a href="https://pixabay.com/"><img src="<?= plugin_dir_url(__FILE__).'img/logo.png' ?>" style="width:120px;margin:0 5px;position:relative;top:5px"></a> plugin by <a href="https://pixabay.com/service/about/">Simon Steinberger</a> and <a href="http://efs.byrev.org/">Emilian Robert Vicol</a>.
        Serbian translation by <a href="http://firstsiteguide.com/">Ogi Djuraskovic</a>.
    </p>
    <p>Find us on <a href="https://www.facebook.com/pixabay">Facebook</a>, <a href="https://plus.google.com/+Pixabay">Google+</a> and <a href="https://twitter.com/pixabay">Twitter</a>.</p>
    </div> -->
<?php }


function dfsp_options_validate($input){
    global $dfsp_gallery_languages;
    $options = get_option('dfsp_options');
    // if ($dfsp_gallery_languages[$input['language']]) $options['language'] = $input['language'];
    // if ($input['safesearch']) $options['safesearch'] = 'true'; else $options['safesearch'] = 'false';
    if ($input['attribution']) $options['attribution'] = 'true'; else $options['attribution'] = 'false';
    if ($input['button']) $options['button'] = 'true'; else $options['button'] = 'false';
    return $options;
}
?>
